=== modified file 'src/com/goldencode/p2j/uast/ClassDefinition.java'
--- old/src/com/goldencode/p2j/uast/ClassDefinition.java	2022-05-16 16:24:45 +0000
+++ new/src/com/goldencode/p2j/uast/ClassDefinition.java	2022-05-23 20:10:15 +0000
@@ -3316,381 +3677,466 @@
     *
     * @return   Resource found or <code>null</code> if no match exists.
     */
-   private MemberData fuzzyMethodLookup(String         name,
-                                        ParameterKey[] caller,
-                                        int            access,
-                                        boolean        isStatic,
-                                        boolean        internal,
-                                        Aast           node)
+   private MethodSearchResult fuzzyMethodLookup(String         name,
+                                                ParameterKey[] caller,
+                                                int            access,
+                                                boolean        isStatic,
+                                                boolean        internal,
+                                                Aast           node)
    {
-      MemberData mdat = null;
-      
-      boolean polyParams = false;
-      for (ParameterKey p : caller)
-      {
-         if ("BaseDataType".equals(p.type))
-         {
-            polyParams = true;
-            break;
-         }
-      }
-      
       boolean first = isSetParam(name);
       
-      List<MemberData> list = candidates(name, caller.length, access, isStatic, internal, first, null);
+      List<MatchMetrics> list = candidates(name, caller.length, access, isStatic, internal, first, null);
+      
+      boolean debug = false;
+      
+      if (debug)
+      {
+         System.out.println("\n\n--------------------fuzzyMethodLookup START--------------------\n");
+         
+         System.out.printf("\n   CALLER %s\n   PARAMETERS: %d\n", node.dumpTree(true), caller.length);
+         
+         for (int i = 0; i < caller.length; i++)
+         {
+            System.out.printf("      %s\n", caller[i]);
+         }
+         
+         for (MatchMetrics m : list)
+         {
+            System.out.printf("DEBUG: %s\n", m.data);
+         }
+      }
             
       // quick out if there are no possible matches
       if (list.isEmpty())
       {
+         if (debug)
+            System.out.println("--------------------fuzzyMethodLookup QUICK OUT--------------------");
+         
          return null;
       }
       
       // special case for ParameterList.setParameter()
       if (first && list.size() == 1)
       {
-         return list.get(0);
+         return new MethodSearchResult(list.get(0).data, null);
       }
-      
-      // the fuzzy lookup is done in phases
-      // 1. collect all matches, regardless of parameter modes
-      // 2. if only one match found, use that
-      // 3. if multiple matches found:
-      // - if one exact match by exact parameter type, use that
-      // - if multiple matches, get by parameter modes
-      //   > if caller hasn't specified a mode for an argument, use wildcard
-      //   > only one match should be found
-      //   > if multiple matches, show warning
-      
-      List<MemberData> matches = new ArrayList<>();
-      List<MemberData> exactMatches = new ArrayList<>();
-      
-      // TODOS:
-      // - constructors
-      // - handle dynamic invocation marking here
-      // - tables/table handles
-      // - datasets/dataset handles
-      // - object fuzziness
-      // - does primitive type fuzziness have less priority than primitive type exact matches?
+
+      String[] error = new String[1];
+      
+      boolean polyArgs = false;
+      
+      // TODO: constructors
+
+      // PHASE 1: cut down the list of all matches to include only those which are potentially valid
+      
+      if (debug)
+         System.out.println("\n\n---PHASE 1 START---\n");
 
       // process each parameter from left to right; the processing will vary by the parameter type; some
-      // types (e.g. objects) have multi-phase checks and other types are a simple comparison; at each
+      // types (e.g. objects) have multi-step checks and other types are a simple comparison; at each
       // step of the way the list of possible candidates will be reduced until there are only candidates
-      // left which match all criteria; at that point if there are more than one then we either have a 
-      // dynamic invocation scenario or there is some ambiguity (which should not happen if the code
-      // compiles in the 4GL)
+      // left which COULD match all criteria; at that point if there are more than one then we have an
+      // additional disambiguation step, a dynamic invocation scenario or there is some ambiguity (which
+      // should not happen if the code compiles in the 4GL)
       
-      // OUTLINE FOR NEXT CHANGES
-      /* 
-      caller:
+      // process the caller's parameters, left to right; for each caller parameter we examine the matching
+      // parameter in the list of candidates, removing any candidates in the list that cannot match
       for (int i = 0; i < caller.length; i++)
       {
+         final int idx = i;
+         
+         final Integer callerMode = caller[i].mode;
+         
          // if the caller is passing Java types, then we match them as if they were 4GL types so the get
          // converted here; if they are already 4GL types then no change will happen
-         String callerType = fromJava(caller[i].type);
-         
-         // wildcards: unknown value or BDT (POLY cases) match anything (no cases can be excluded)
-         if (callerType == null                     ||
-             callerType.equals("BaseDataType")      ||
-             callerType.equals("unknown"))
-         {
-            continue caller;
-         }
-         
-         // primitive types
-         
-         // primitive types widening/narrowing
-         
-         // tables/table handles
-         
-         // handles passed to table
-         
-         // datasets/dataset handles
-         
-         // handles passed to datasets
-         
-         // buffers
-         
-         // extents
-         
-         // object direct match
-         
-         // object fuzziness
-         
-         // parameter modes
-      }
-      */
-      
-      Iterator<MemberData> iter = list.iterator();
-      
-      outer:
-      while (iter.hasNext())
-      {
-         MemberData dat = iter.next();
-         
-         ParameterKey[] candidate = dat.signature;
-         
-         boolean exact = true;
-         
-         inner:
+         final String  callerType = fromJava(caller[i].type);
+         
+         // these are all specific to the current parameter
+         Predicate<MatchMetrics> exactMatch = (m) -> callerType.equals(fromJava(m.data.signature[idx].type)); 
+         Predicate<MatchMetrics> isTable    = (m) -> m.data.signature[idx].type.startsWith("TEMP-TABLE");
+         Predicate<MatchMetrics> isTH       = (m) -> "TABLE-HANDLE".equals(m.data.signature[idx].type);
+         Predicate<MatchMetrics> isDataset  = (m) -> m.data.signature[idx].type.startsWith("DATASET <");
+         Predicate<MatchMetrics> isDH       = (m) -> "DATASET-HANDLE".equals(m.data.signature[idx].type);
+         Predicate<MatchMetrics> modeMatch  = (m) -> callerMode.equals(m.data.signature[idx].mode);
+
+         // exclude any candidates which cannot ever match due to a caller MODE constraint; a null for the
+         // caller's mode is a wildcard that can match any mode in the parameter definition; this means that
+         // when the caller's mode is null, no matches can be excluded
+         if (callerMode != null)
+         {
+            list.removeIf(modeMatch.negate());
+            
+            if (debug)
+               System.out.printf("PARM %d: mode %d\n", idx, list.size());
+         }
+
+         // TYPE-specific processing
+         
+         boolean poly = (callerType == null) || callerType.equals("BaseDataType");
+         
+         // TYPE wildcards: unknown value or BDT (POLY cases) match any TYPE
+         if (poly || callerType.equals("unknown"))
+         {
+            list.stream().forEach((m) -> m.wildcard++);
+            
+            if (poly)
+               polyArgs = true;
+            
+            // no cases can be excluded based on type; the list remains unchanged
+            if (debug)
+               System.out.printf("PARM %d: type wildcard %d\n", idx, list.size());
+         }
+         else
+         {
+            // table parameters
+            if (callerType.startsWith("TEMP-TABLE"))
+            {
+               // check for any exact TYPE matches
+               if (!processExactMatches(list, exactMatch))
+               {
+                  // allow a match to a table-handle if there is only 1 table-handle option
+                  allowIfOnlyOne(list, isTH, idx, callerType, error);
+               }
+               
+               if (debug)
+                  System.out.printf("PARM %d: TT %d\n", idx, list.size());
+            }
+
+            // table handles
+            else if (callerType.equals("TABLE-HANDLE"))
+            {
+               // at this point we can't know if we have a match, we can just remove anything that is not
+               // a table-handle or table; we defer the matching to the next phase once all other removals
+               // are done               
+               list.removeIf(isTH.or(isTable).negate());
+               list.stream().forEach((m) -> m.cvt++);
+               
+               if (debug)
+                  System.out.printf("PARM %d: TH %d\n", idx, list.size());
+            }
+            
+            // dataset parameters
+            else if (callerType.startsWith("DATASET <"))
+            {
+               // check for any exact TYPE matches
+               if (!processExactMatches(list, exactMatch))
+               {
+                  // allow a match to a dataset-handle if there is only 1 dataset-handle option
+                  allowIfOnlyOne(list, isDH, idx, callerType, error);
+               }
+               
+               if (debug)
+                  System.out.printf("PARM %d: DS %d\n", idx, list.size());
+            }
+            
+            // dataset handles
+            else if (callerType.equals("DATASET-HANDLE"))
+            {
+               // at this point we can't know if we have a match, we can just remove anything that is not
+               // a dataset-handle or dataset; we defer the matching to the next phase once all other
+               // removals are done               
+               list.removeIf(isDH.or(isDataset).negate());
+               list.stream().forEach((m) -> m.cvt++);
+               
+               if (debug)
+                  System.out.printf("PARM %d: DH %d\n", idx, list.size());
+            }
+
+            // buffers
+            else if (callerType.startsWith("BUFFER"))
+            {
+               // only an exact match works (handled above); no fuzzy matching here
+               list.removeIf(exactMatch.negate());
+               list.stream().forEach((m) -> m.exact++);
+               
+               if (debug)
+                  System.out.printf("PARM %d: buf %d\n", idx, list.size());
+            }
+
+            // must be one of the BaseDataType wrapper classes
+            else
+            {
+               final int     extIdx    = callerType.indexOf("[");
+               final int     extVal    = (extIdx == -1) ? 0 : getExtent(callerType);
+               final String  basicType = (extIdx == -1) ? callerType : callerType.substring(0, extIdx);
+
+               // extents
+               processExtentMatches(list, extVal, idx);
+               
+               if (debug)
+                  System.out.printf("PARM %d: after extent processing %d\n", idx, list.size());
+
+               // primitive and OO types widening/narrowing
+               // WARNING: this code is not idempotent, we modify the MemberMetrics instances of any that
+               //          are matched; this is BAD BAD BAD, but the widening/narrowing calculation is very
+               //          expensive so it makes no sense to duplicate that work
+               Predicate<MatchMetrics> isTypeMatch = (mem) -> 
+               {
+                  String base = mem.data.signature[idx].scalarType();
+                  
+                  Runnable increment = () -> mem.ooLvl[idx]++;
+                  
+                  // exact match to the base portion of the type will match for any mode (and is the only
+                  // possible match for input-output mode); for the rest of the cases we check the 
+                  // parameter mode at the definition (the caller might be unspecified (wildcard) but the
+                  // definition must be specified
+                  if (basicType.equals(base))
+                  {
+                     // yes, this is not idempotent; get over it
+                     mem.exact++;
+                     
+                     return true;
+                  }
+                  else if (mem.data.signature[idx].mode == KW_INPUT)
+                  {
+                     boolean widen = isWideningTypeMatch(basicType, base, increment);
+                     
+                     if (widen)
+                     {
+                        // yes, this is not idempotent; get over it
+                        mem.cvt++;
+                     }
+                     
+                     return widen;
+                  }
+                  else if (mem.data.signature[idx].mode == KW_OUTPUT)
+                  {
+                     boolean narrow = isNarrowingTypeMatch(basicType, base, increment);
+                     
+                     if (narrow)
+                     {
+                        // yes, this is not idempotent; get over it
+                        mem.cvt++;
+                     }
+                     
+                     return narrow;
+                  }
+                  
+                  return false;
+               };
+   
+               // WARNING: because isTypeMatch is not idempotent we make sure to only process it once
+               list.removeIf(isTypeMatch.negate());
+               
+               if (debug)
+                  System.out.printf("PARM %d: BDT type match %d\n", idx, list.size());
+            }
+         }
+      }
+
+      if (debug)
+      {
+         System.out.println("\n\n---PHASE 1 END---\n\n");
+         
+         for (MatchMetrics m : list)
+         {
+            System.out.printf("DEBUG: %s\n", m);
+         }
+      }
+      
+      // PHASE 2: if there are > 1 candidates we need to disambiguate based on priorities
+      
+      // unknown value, wildcard modes cannot be used to disambiguate
+      
+      if (list.size() > 1)
+      {
+         MethodSearchResult dyn = new MethodSearchResult();
+         
+         // POLY arguments activates runtime/dynamic mode
+         if (polyArgs)
+         {
+            if (debug)
+               System.out.println("\n\n---------fuzzyMethodLookup DYNAMIC POLY!---------\n");
+            
+            return dyn; 
+         }
+
+         // TABLE-HANDLE/DATASET-HANDLE arguments deferred processing; we don't calculate this earlier
+         // because some possible matches that would have been seen then may have been dropped by
+         // processing of later parameters; this means that we must handle the possible compile time and
+         // runtime matches here
+         final int[] numTB = new int[caller.length];
+         final int[] numTH = new int[caller.length];
+         final int[] numDS = new int[caller.length];
+         final int[] numDH = new int[caller.length];
+
          for (int i = 0; i < caller.length; i++)
          {
-            String candidateType = candidate[i].type;
-            String callerType = caller[i].type;
-            candidateType = fromJava(candidateType);
-            callerType = fromJava(callerType);
-
-            if (candidateType.equals(callerType))
-            {
-               // exact match, try the next one
-               continue inner;
-            }
-            else
-            {
-               if ("TEMP-TABLE".equals(candidateType) || 
-                   "TABLE-HANDLE".equals(candidateType))
-               {
-                  // handle can be passed to TABLE-HANDLE or DATASET-HANDLE in 4GL
-                  if ("TEMP-TABLE".equals(callerType) || 
-                      "TABLE-HANDLE".equals(callerType) ||
-                      "handle".equals(callerType))
-                  {
-                     continue inner;
-                  }
-                  
-                  continue outer;
-               }
-               else if ("DATASET".equals(candidateType) || 
-                        "DATASET-HANDLE".equals(candidateType))
-               {
-                  // handle can be passed to TABLE-HANDLE or DATASET-HANDLE in 4GL,
-                  // FWD doesn't support this at this time, so ignore it here.
-                  if ("DATASET".equals(callerType) || 
-                      "DATASET-HANDLE".equals(callerType))
-                  {
-                     continue inner;
-                  }
-                  
-                  continue outer;
-               }
-               else if (candidateType.startsWith("BUFFER"))
-               {
-                  if (callerType.equals(candidateType))
-                  {
-                     continue inner;
-                  }
-                  
-                  continue outer;
-               }
-               
-               // unknown value or BDT (POLY cases) match anything
-               if (callerType == null                     ||
-                   callerType.equals("BaseDataType")      ||
-                   callerType.equals("unknown")           || 
-                   candidateType.equals("Object"))
-               {
-                  exact = false;
-                  continue inner;
-               }
-               
-               // exact match on type but fuzzy extent spec match
-               int idx1 = candidateType.indexOf("[");
-               int idx2 = callerType.indexOf("[");
-               
-               boolean extentMatch = isExtentMatch(candidateType, callerType);
-               
-               if (idx1 != -1 && idx2 != -1)
-               {
-                  int ex1 = getExtent(candidateType);
-                  int ex2 = getExtent(callerType);
-                  
-                  candidateType = candidateType.substring(0, idx1);
-                  callerType = callerType.substring(0, idx2);
-                  
-                  extentMatch = extentMatch || ex1 == ex2 || ex1 == -1 || ex2 == -1;
-                  
-                  if (candidateType.equals(callerType))
-                  {
-                     if (extentMatch)
-                     {
-                        // match
-                        continue inner;
-                     }
-                     else
-                     {
-                        // not a match
-                        continue outer;
-                     }
-                  }
-               }
-               
-               exact = false;
-
-               // check the parameter mode at the definition
-               if (candidate[i].mode == KW_INPUT)
-               {
-                  // widening matches are OK, narrowing are NOT OK
-                  if (isWideningTypeMatch(callerType, candidateType) && extentMatch)
-                  {
-                     // match
-                     continue inner;
-                  }
-                  else
-                  {
-                     // not a match
-                     continue outer;
-                  }
-               }
-               else if (candidate[i].mode == KW_OUTPUT)
-               {
-                  // narrowing matches are OK, widening are NOT OK
-                  if (isNarrowingTypeMatch(callerType, candidateType) && extentMatch)
-                  {
-                     // match
-                     continue inner;
-                  }
-                  else
-                  {
-                     // not a match
-                     continue outer;
-                  }
-               }
-               else if (candidate[i].mode == KW_IN_OUT)
-               {
-                  // exact match is required
-                  if (!candidateType.equals(callerType))
-                  {
-                     // not a match
-                     continue outer;
-                  }
-               }
-            }
-         }
-         
-         // if we are here, we found a signature match; ignore not the right type
-         if (dat != null && ((!isStatic && (!dat.isStatic || internal)) ||
-                             (isStatic && dat.isStatic)))
-         {
-            matches.add(dat);
-            
-            if (exact)
-            {
-               exactMatches.add(dat);
-            }
-         }
-         else
-         {
-            // clear our result
-            dat = null;
-         }
-      }
-
-      if (matches.size() == 1)
-      {
-         mdat = matches.get(0);
-         return mdat;
-      }
-      else if (exactMatches.size() == 1)
-      {
-         mdat = exactMatches.get(0);
-         return mdat;
-      }
-      
-      // multiple fuzzy matches, get by parameter mode
-      iter = matches.iterator();
-      
-      outer:
+            final int idx = i;
+            
+            String callerType = fromJava(caller[i].type);
+         
+            if ("TABLE-HANDLE".equals(callerType))
+            {
+               Predicate<MatchMetrics> isTable = (m) -> m.data.signature[idx].type.startsWith("TEMP-TABLE");
+               Predicate<MatchMetrics> isTH    = (m) -> "TABLE-HANDLE".equals(m.data.signature[idx].type);
+
+               Consumer<MatchMetrics> trackT = (m) ->
+               {
+                  if (isTable.test(m))
+                  {
+                     numTB[idx]++;
+                  }
+                  else if (isTH.test(m))
+                  {
+                     numTH[idx]++;
+                  }
+               };
+
+               list.forEach(trackT);
+               
+               if (numTH[idx] == 1 && numTB[idx] == 0)
+               {
+                  list.removeIf(isTH.negate());
+                  break;
+               }
+               else if (numTH[idx] == 0 && numTB[idx] == 1)
+               {
+                  list.removeIf(isTable.negate());
+                  break;
+               }
+               else if ((numTH[idx] + numTB[idx]) > 1)
+               {
+                  // dynamic mode
+                  if (debug)
+                     System.out.println("\n\n---------fuzzyMethodLookup DYNAMIC TABLE-HANDLE!---------\n");
+                  
+                  return dyn;
+               }
+               else
+               {
+                  // no matches
+                  list.clear();
+                  error[0] = String.format("No possible matches for parameter %d of type %s.",
+                                           idx,
+                                           callerType);
+                  break;
+               }
+            }
+            
+            if ("DATASET-HANDLE".equals(callerType))
+            {
+               Predicate<MatchMetrics> isDataset = (m) -> m.data.signature[idx].type.startsWith("DATASET <");
+               Predicate<MatchMetrics> isDH      = (m) -> "DATASET-HANDLE".equals(m.data.signature[idx].type);
+            
+               Consumer<MatchMetrics> trackD = (m) ->
+               {
+                  if (isDataset.test(m))
+                  {
+                     numDS[idx]++;
+                  }
+                  else if (isDH.test(m))
+                  {
+                     numDH[idx]++;
+                  }
+               };
+               
+               list.forEach(trackD);
+            
+               if (numDH[idx] == 1 && numDS[idx] == 0)
+               {
+                  list.removeIf(isDH.negate());
+                  break;
+               }
+               else if (numDH[idx] == 0 && numDS[idx] == 1)
+               {
+                  list.removeIf(isDataset.negate());
+                  break;
+               }
+               else if ((numDH[idx] + numDS[idx]) > 1)
+               {
+                  // dynamic mode
+                  if (debug)
+                     System.out.println("\n\n---------fuzzyMethodLookup DYNAMIC DATASET-HANDLE!---------\n");
+                  
+                  return dyn;
+               }
+               else
+               {
+                  // no matches
+                  list.clear();
+                  error[0] = String.format("No possible matches for parameter %d of type %s.",
+                           idx,
+                           callerType);
+                  break;
+               }
+            }            
+         }
+      }
+
+      // exact vs fuzzy weighting disambiguation if needed
+      if (list.size() > 1)
+      {
+         // use the natural ordering of the metrics class to find the best match
+         Collections.sort(list, Collections.reverseOrder());
+         
+         MatchMetrics best     = list.get(0);
+         MatchMetrics runnerUp = list.get(1);
+         
+         // safety check; if it fails we report the ambiguity below
+         if (best.compareTo(runnerUp) == 1)
+         {
+            // clear everything except the best match
+            list = new LinkedList<>();
+            list.add(best);
+         }
+      }
+      
+      if (list.size() == 1)
+      {
+         // "there can be only one"
+         if (debug)
+            System.out.println("\n\n----------------fuzzyMethodLookup HIGHLANDER!----------------\n");
+         
+         MatchMetrics match = list.get(0);
+         
+         return new MethodSearchResult(match.data, match.overrides);
+      }
+      else if (list.isEmpty())
+      {
+         if (debug)
+         {
+            // if we still have ambiguous matches, display any stored error
+            if (error[0] != null)
+            {
+               System.out.println(error[0]);
+            }
+
+            System.out.println("\n\n----------------fuzzyMethodLookup NO MATCH SUCKA!----------------\n");
+         }
+         
+         return null;
+      }
+
+      System.out.println("WARNING: more than one method def found using fuzzy lookup: " + name + 
+                         " from class " + getName());
+      
+      System.out.printf("\n   CALLER %s\n   PARAMETERS: %d\n", node.dumpTree(true), caller.length);
+      
+      for (int i = 0; i < caller.length; i++)
+      {
+         System.out.printf("      %s\n", caller[i]);
+      }
+ 
+      Iterator<MatchMetrics> iter = list.iterator();
+      int num = 0;
+      
       while (iter.hasNext())
       {
-         MemberData dat = iter.next();
-         ParameterKey[] candidate = dat.signature;
-         
-         inner:
-         for (int i = 0; i < candidate.length; i++)
-         {
-            Integer candidateMode = candidate[i].mode;
-            Integer callerMode = caller[i].mode;
-            
-            if (Objects.equals(candidateMode, callerMode) || callerMode == null)
-            {
-               // either the same or the caller hasn't specified the argument mode
-               // TODO: the mode is not mandatory at the definition... assume INPUT?
-               continue inner;
-            }
-            else
-            {
-               // mismatch
-               continue outer;
-            }
-         }
-         
-         // found a match
-         if (mdat != null)
-         {
-            // add a logging that more than one definition matches this fuzzy
-            // signature
-            System.out.println("WARNING: more than one method def found " + 
-                               "using fuzzy lookup: " + mdat.name + 
-                               " from class " + getName());
-            
-            boolean print = true;
-            
-            if (fuzzyErrors != null)
-            {
-               if (fuzzyErrors.contains(mdat.name))
-               {
-                  print = false;
-               }
-            }
-            else
-            {
-               fuzzyErrors = new HashSet();
-            }
-            
-            if (print)
-            {
-               fuzzyErrors.add(mdat.name);
-               
-               System.out.printf("\n- access %s, static %b\n" +
-                                 "   PARAMETERS: %d\n", 
-                                 ProgressParser.lookupTokenName(mdat.access),
-                                 mdat.isStatic,
-                                 mdat.signature.length);
-               for (int i = 0; i < mdat.signature.length; i++)
-               {
-                  System.out.printf("      %s\n", mdat.signature[i]);
-               }
-               
-               System.out.printf("\n- access %s, static %b\n" +
-                                 "   PARAMETERS: %d\n", 
-                                 ProgressParser.lookupTokenName(dat.access),
-                                 dat.isStatic,
-                                 dat.signature.length);
-               for (int i = 0; i < dat.signature.length; i++)
-               {
-                  System.out.printf("      %s\n", dat.signature[i]);
-               }
-               
-               System.out.printf("\nby caller %s\n   PARAMETERS: %d\n", 
-                                 node.dumpTree(true), 
-                                 caller.length);
-               for (int i = 0; i < caller.length; i++)
-               {
-                  System.out.printf("      %s\n", caller[i]);
-               }
-            }
-            
-            if (polyParams)
-            {
-               return null;
-            }
-            
-            break outer;
-         }
+         MatchMetrics dat = iter.next();
+         
+         System.out.printf("   MATCH %d: %s\n\n", num, dat.toString());
+         num++;
+      }
+      
+      if (debug)
+         System.out.println("\n\n--------------------fuzzyMethodLookup BITTER END---------------------\n");
 
-         mdat = dat;
-      }
+      // return the first one in the sorted list
+      MatchMetrics match = list.get(0);
       
-      return mdat;
+      return new MethodSearchResult(match.data, match.overrides);
    }
    
    /**
